function L = L_timeaverage(tTP,TP,t)
% Function to calculate terminus position change over defined intervals

% arguments(input)
% tTP   - time of terminus position record as matlab datenum
% TP    - terminus position record in metres
% t     - intervals of time over which to calculate terminus position change

% arguments(output
% L.t - midpoint of time intervals on which output data defined
% L.L - terminus position change during intervals

% interpolate terminus position onto t
TP_interp = interp1(tTP,TP,t,'linear',NaN);

% terminus position change during interval in km
L.L = diff(TP_interp)/1000;

% output time
L.t = 0.5*(t(1:end-1)+t(2:end));

end
