% Function reads in all TermPicks terminus positions and filters them to
% only keep terminus positions that are closest to the 1st of the
% respective month. 
% arguments: (input)
% AllTerminiPath - Path to TermPicks dataset.
%
% arguments: (output) 
% MonthlyTPSelectFolder - Specifies the path to the selected monthly terminus positions

function MonthlyTPSelectFolder =  MonthlyTPSelection(AllTerminiPath)

tePosTemp = shaperead(AllTerminiPath);
FileName = strsplit(AllTerminiPath,'/');
GlacierName = FileName{3};
%%
Afields = fieldnames(tePosTemp);
Acell = struct2cell(tePosTemp);
sz = size(Acell);            
Acell = reshape(Acell, sz(1), []);     
Acell = Acell';                        
Acell = sortrows(Acell, 6); 
Acell = reshape(Acell', sz);
SortedTermini = cell2struct(Acell, Afields, 1);
%%
for i=1:length(SortedTermini)
    SortedTermini(i).DateNum = datenum(datetime(str2num(SortedTermini(i).Year),str2num(SortedTermini(i).Month),str2num(SortedTermini(i).Day)));
    SortedTermini(i).GroupDate = datenum(datetime(str2num(SortedTermini(i).Year),str2num(SortedTermini(i).Month),1));
    CompDateNum(i,1) = datenum(datetime(str2num(SortedTermini(i).Year),str2num(SortedTermini(i).Month),1));
    SortedTermini(i).Diff= min(abs(SortedTermini(i).DateNum - CompDateNum));
    GroupDates(i,1) = SortedTermini(i).GroupDate;
end
%%
Dates = GroupDates;
%Write Depths to differnt cells
transitionDates = diff(Dates)>0;
transitionsIndex = find(transitionDates);
TranIdx = [transitionsIndex(1:end); length(Dates)];
for n=1:length(TranIdx)
    if n>1 && diff(TranIdx(n-1:n))>1==1
        Val =(TranIdx(n)-TranIdx(n-1))-1;
        x{1,n} = SortedTermini((TranIdx(n)-Val):TranIdx(n),1);
    else
        x{1,n} = SortedTermini(TranIdx(n),1);
    end
end
%%
for i=1:length(x)
    for j=1:length(x{i})
        Values(j,1) =x{i}(j).Diff;
        indMin = find(Values==min(Values));
    end
        if length(indMin)>1==1
            for k=1:length(x{i})
                XValues(:,1) = length(x{i}(k).X);
                indXMin = find(XValues==max(XValues));
                NewStruct(i) = x{i}(indXMin);
            end
        else
            NewStruct(i) = x{i}(indMin);
    
        end
        clear Values XValues indMin indXMin
end
%%
OutFolderAll = 'Data/Monthly_TP_Select/';
if ~exist(OutFolderAll)
        mkdir(OutFolderAll)
    end
shapewrite(NewStruct,strcat(OutFolderAll,GlacierName,'.shp'))
MonthlyTPSelectFolder =strcat(OutFolderAll,GlacierName,'.shp');
end
